/*
 *  (C) Copyright 2002,2003 Sergiusz Rozanski <rozanski@sergiusz.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
		  

#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <time.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>		     
#include <arpa/inet.h>
#include <stdarg.h>		     

#define SIZE sizeof(struct sockaddr_in)

#ifdef WORDS_BIGENDIAN
#define swap_short(sh) (sh)
#else
#define swap_short(sh) ((((sh)&0xff00)>>8)|(((sh)&0x00ff)<<8))
#endif

// globale
void catcher(int sig);
int newsockfd;
char home[101];
char dirgg[21];

/*
cgi  = 1 - tryb cgi
flbw = 1 - tryb freeblwr
maxslots - ilosc slotow dla freeblwr, domyslnie 30
aauth = 1 - alternatywne logowanie przez link
noold = 1 - gdy 0 pisze wap-log i oldwap, gdy 1 nie pozostawia adnej historii
nopl = 0 - gdy 0 pisze po polsku, gdy 1, pisze polskawo
*/
int icgi=0,fblw=0,maxslots=30,aauth=0,noold=0,nopl=0;

int debug=1; // 0-nic nie wywietlaj, 1-tylko komunikaty, 2-komunikaty i output

char logname[51];
long int fbuser=0;

#include "mincrypt.c"
#include "sendmail.c"
#include "wap.c"
// #include "www.c"

/*
funkcja czyci katalog slotu o podanym numerze
gdy kat==1 kasuje rwnie sam katalog
*/

int clrdir(int slot,int kat) {
struct dirent **namelist;
char wapfile[201],tmp[201];
int n,k;

    //wyczysc katalog
    snprintf(tmp,sizeof(tmp),"%s/%d/",home,slot);
    n = scandir(tmp, &namelist, 0, alphasort);
    if (n < 0) {
	// jakis problem z lista katalogow
	if(debug>0)printf("[%d] Problem z katalogiem: %s\n",slot,tmp);
        return 0;
	}
    else {
        k=n;
        while(n--) {
	    snprintf(wapfile,sizeof(wapfile),"%s%s",tmp,namelist[k-n-1]->d_name);
	    unlink(wapfile);
	    }
	free(namelist[k-n-1]);
	}
    free(namelist);
    
    if(kat==1) {
	snprintf(tmp,sizeof(tmp),"%s/%d/",home,slot);
	rmdir(tmp);
	}
    
    return 0;
}

/*
funkcja szuka wolnego slotu dla freeblwr mode
jeli go znajdzie zwraca jego numer, jeli go nie znajdzie
zwraca zero
*/

int findslot(void) {
int i,fs=0;
char tmp[201];
struct stat buf;
time_t tczas;
long int czas=0;

time(&tczas);

//szukam wogole wolnego slotu
for(i=1;i<=maxslots;i++) {
    snprintf(tmp,sizeof(tmp),"%.150s/%d",home,i);
    if(mkdir(tmp,0700)==0) { // znaleziono slot
	if(debug>0)printf("[search] Znaleziono wolny slot %d\n",i);
	return i;
	}
    }

//szukam najstarszego slotu
if(debug>0)printf("[search] Brak wolnych slotow szukam najstarszego\n");
for(i=1;i<=maxslots;i++) {
    snprintf(tmp,sizeof(tmp),"%.150s/%d/wap-query.log",home,i);
    if(lstat(tmp,&buf)==0) {
	if(buf.st_mtime<czas || czas==0) {
	    czas=buf.st_mtime;
	    fs=i;
	    }
	}
    }
if(debug>0)printf("[search] Najstarszy slot %d\n",fs);

if(fs==0)
    return 0;

// jeli najstarsze gniazdo byo urzywane w cigu 10 minut to
// go nie mona urzywa

if((tczas-czas)<600) {
    if(debug>0)printf("[search] Slot %d nadal urzywany\n",fs);
    return 0;
    }

//jesli bardzo stary
snprintf(tmp,sizeof(tmp),"%.150s/%d/wap-query.log",home,fs);
if(unlink(tmp)==0) {
    FILE *pwap;

    //tylko 1 proces tu wejdzie jesli szukalo wiecej (jeden zdarzy odlinkowac plik)
    //mozna by poszukac jeszcze, ale nie ma wogole wolnych
    //a jeszcze 2 naraz sie dobija

    //zatrzymaj ekg
    
    if(debug>0)printf("[search] slot %d przedawniony\n",fs);
    snprintf(tmp,sizeof(tmp),"%.150s/%d/pipewap",home,fs);
    if((pwap=fopen(tmp,"r+"))) {
	//znaczy sie dziala
	fprintf(pwap,"/quit\n");
	fclose(pwap);
	sleep(2); //daj mu czas na zamkniecie
	}
    
    clrdir(fs,0);

    return fs;
    } //udal sie unlink

//sorry, no free slots
return 0;
}

int main(int a, char **b)
{
    int sockfd,w,auth,k,kk;
    char c;
    char line[1001];
    char ol[14101];
    char wout[14001];
    char qstr[501];
    struct sockaddr_in server;
    static struct sigaction act;
    char passfilename[100],*orglogin,*orgpass;
    char listen_ip[16];
    FILE *passfile;
//    char *pass,*login;
    char *r;
//    int snumber;

//    char ekgwbmp[]={0,0,32,16,123,118,-8,-83,-96,5,-5,-85,-49,-5,-8,-102,-97,-3,-5,-86,63,-16,-8,-83,-65,-24,-1,-1,-65,-6,-1,-17,-65,-2,-1,95,62,-18,-2,-65,-65,30,-3,-33,-65,-66,-5,-65,-65,-50,-9,127,31,-15,46,-1,-49,-5,-35,-1,-96,4,-69,-1,119,119,87,-1};
//    char ekgwbmp[]={0,0,96,24,127,-95,87,-2,31,-1,-1,-4,15,-1,-1,-1,30,0,3,-4,31,-1,-1,-8,15,-3,-1,-1,-128,2,-96,124,-65,-1,-1,-4,15,-64,127,-1,-64,7,-6,56,-1,-1,-1,-12,4,0,63,-1,-63,-17,-1,1,-1,-1,-1,-16,0,0,31,-1,-57,-1,-1,3,-1,-1,-1,-64,2,0,15,-1,-121,-65,-1,-57,-1,-1,-1,-28,16,-128,79,-1,-113,28,127,71,-1,-1,-1,-32,0,20,15,-1,-33,30,127,-57,-1,-1,-1,-64,0,0,7,-1,-113,-66,-1,-49,-1,-1,-1,-32,0,-111,47,-1,-97,-1,-1,-57,-1,-1,-41,-32,75,124,3,-1,-49,-1,-1,-29,-1,-1,1,96,15,-7,34,-97,63,-1,-1,-64,-1,-2,32,32,7,-3,16,15,-114,127,-1,-32,31,-2,122,2,79,-4,2,-93,-98,62,-97,-50,7,-1,63,-64,36,-128,15,-31,-122,31,63,-57,-127,-2,63,-6,32,68,47,-11,15,12,63,-49,-32,-2,-113,-2,16,17,-25,-8,71,-126,-65,-113,-8,-1,15,-1,-120,8,-63,-7,-29,-48,-1,-105,-1,-1,3,-1,-96,1,-93,-3,-15,-1,-1,3,-1,-1,-109,-1,-64,0,-1,-1,-8,-17,-3,35,-1,-1,67,-1,-30,0,127,-1,-16,63,-2,80,-1,-3,1,127,-32,0,47,-1,-16,4,-96,96,-1,-44,56,127,-64,0,23,-1,0,0,0,0,0,0,0,0,0,0,0,0};
//    char ekgwbmp[]={0,0,96,24,-1,-1,-1,-1,-1,-1,-1,-1,-1,-4,-8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-13,11,63,-1,-1,-1,-1,-1,-2,-1,-1,-1,-73,-9,-65,-1,-1,-1,-1,-1,-34,-9,-1,-4,71,-9,-65,-1,-1,-1,-1,-1,-34,-9,-9,-15,-5,-2,127,-64,57,-57,0,127,-24,47,-9,-50,-1,-1,127,-49,-7,-97,62,127,-25,-49,-9,63,127,-2,-109,-49,-7,63,63,-3,-33,-9,96,63,-1,-8,-83,-63,-8,127,56,126,63,-8,-17,-113,-1,-27,125,-49,-7,63,62,127,-77,-101,-17,-97,-1,-80,120,-49,-7,-113,62,127,115,-99,-24,-97,-93,71,-4,-64,57,-29,0,127,127,-3,-24,-83,84,-89,-6,-1,-1,-1,-1,-8,127,-4,40,-94,15,11,-11,-1,-1,-1,-1,-1,111,-19,-17,-65,-33,-1,-23,-1,-1,-1,-1,-1,111,-20,-25,-97,-49,-7,83,-1,-51,-35,-16,63,-73,-37,10,-97,-12,-16,-89,-1,-20,-70,-9,-66,56,56,-113,-97,-5,55,15,-1,-22,-78,112,61,-33,-9,74,-97,-1,-49,-1,-1,-30,48,119,-1,-25,-49,-17,-97,-1,-1,-1,-1,-9,103,55,-1,-24,47,-32,60,31,-1,-1,-1,-1,-1,-1,-1,-34,-9,-1,-3,-3,-24,51,-1,-1,-1,-1,-1,-34,-9,-1,-4,125,-18,-21,-1,-1,-1,-1,-1,-2,-1,-1,-3,-3,-18,-31,-1,-1,-1,-1,-1,-1,-1,-1,-4,28,46,-34,-1,-1,-1,-1,-1,-1,-1,-1,-1};
    char ekgwbmp[]={0,0,96,24,-1,-1,-1,-1,-1,-1,-1,-1,-1,-4,-8,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-13,11,63,-1,-1,-1,-1,-1,-2,-1,-1,-1,-73,-9,-65,-1,-1,-1,-1,-1,-34,-9,-1,-4,71,-9,-65,-1,-1,-1,-1,-1,-34,-9,-9,-15,-5,-2,127,-1,-1,-1,-1,-1,-24,47,-9,-50,-1,-1,127,-64,24,1,-128,31,-25,-49,-9,63,127,-2,-109,-49,-97,-97,-97,-99,-33,-9,96,63,-1,-8,-83,-49,-97,-97,-97,-2,63,-8,-17,-113,-1,-27,125,-49,-97,-97,-100,31,-77,-101,-17,-97,-1,-80,120,-64,31,-97,-97,-97,115,-99,-24,-97,-93,71,-4,-52,127,-97,-97,-97,127,-3,-24,-83,84,-89,-6,-50,63,-97,-97,-104,127,-4,40,-94,15,11,-11,-49,-113,-97,-128,31,111,-19,-17,-65,-33,-1,-23,-1,-1,-1,-1,-1,111,-20,-25,-97,-49,-7,83,-1,-1,-1,-1,-1,-73,-37,10,-97,-12,-16,-89,-1,-1,-1,-1,-2,56,56,-113,-97,-5,55,15,-1,-1,-1,-1,-3,-33,-9,74,-97,-1,-49,-1,-1,-1,-121,-1,-1,-25,-49,-17,-97,-1,-1,-1,-16,39,-114,-32,111,-24,47,-32,63,-1,-1,-1,-15,-33,-66,-19,-41,-34,-9,-1,-1,-1,-1,-1,-16,-33,-122,13,-125,-34,-9,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};

//    char jestwbmp[]={0,0,16,16,-18,-1,-10,-9,112,47,-89,-97,-49,-53,-37,-89,-43,79,31,-31,-33,-17,-35,111,-114,-49,103,-121,-16,27,-18,-33,-34,-17,-1,-1};
    char jestwbmp[]={0,0,13,13,-3,-1,-67,-17,-46,95,-17,-65,-38,-33,-33,-33,63,-25,-41,95,-40,-33,-17,-65,-46,95,-67,-17,-3,-1,-1,-1};

//    char sleepwbmp[]={0,0,16,16,-18,-1,-10,-9,112,47,-96,31,-64,11,-64,7,-43,79,8,-127,-64,15,-59,15,-126,15,96,7,-16,27,-18,-33,-34,-17,-1,-1};
    char sleepwbmp[]={0,0,13,13,-3,-1,-67,-17,-48,95,-32,63,-59,31,-64,31,0,7,-56,-97,-57,31,-32,63,-48,95,-67,-17,-3,-1,-1,-1};

//    char busywbmp[]={0,0,16,16,-2,-1,-66,-1,-98,-5,-36,55,-32,-113,-25,-25,-51,-41,26,-89,-33,-16,-61,-9,-104,67,-65,25,-65,-3,-65,-5,-64,7,-2,-1};
    char busywbmp[]={0,0,13,13,-3,-1,-67,-17,-46,95,-17,-65,-38,-33,-37,31,4,-57,-65,-25,127,-41,127,-25,-65,87,-76,-81,-55,31,-1,-1};

    char komorkawbmp[]={0,0,8,13,-49,-61,-67,-67,-91,-91,-67,-83,-75,-83,-75,-67,-61};

    
    if(geteuid()==0) {
	printf("RTG: change mode to user\n");
	return 0;
	}

    memset(&qstr,0,sizeof(qstr));
    snprintf(dirgg,sizeof(dirgg),".gg");
    snprintf(qstr,sizeof(qstr),"%.500s",(char *)getenv("QUERY_STRING"));
    if(strcmp(qstr,"(null)")!=0)icgi=1;
    
    if(icgi==0) {
	snprintf(home,sizeof(home),"%.100s/%s",(char *)getenv("HOME"),dirgg);
	snprintf(logname,sizeof(logname),"%.50s",(char *)getenv("LOGNAME"));
	printf("* RTG (http://gg.overwap.net)\n");
	printf("* Wap server for EKG (http://dev.null.pl/ekg/)\n");
	printf("* (C) 2002,2003 by Elita\n");
	printf("* Home dir/ggdir: %s\n",home);
	if(a>1)
	    printf("* Listen port: %d\n",atoi(b[1]));
	
	memset(&qstr,0,sizeof(qstr));
	memset(&listen_ip,0,sizeof(listen_ip));
	
	if(a>2)
	for(kk=2;kk<a;kk++) {
	    if(strcmp(b[kk],"--freeblwr")==0) {
		// char tmp[100];
		fblw=1;
		noold=0;
		if(kk+1<a)
		    maxslots=atol(b[kk+1]);
		if(maxslots<1)maxslots=30;
		printf("* FreeBlwr mode enabled, slots: %d\n", maxslots);
		}
	    if(strcmp(b[kk],"-u")==0) {
		if(kk+1<a) {
		    snprintf(home+strlen(home),sizeof(home)-strlen(home),"/%.20s",b[++kk]);
		    }
		else {
		    printf("Error: -u need home subdirectory\n");
		    return 0;
		    }
		printf("* User change dir/ggdir: %s\n",home);
		}
	    if(strcmp(b[kk],"-h")==0) {
		if(kk+1<a) {
		    snprintf(listen_ip,sizeof(listen_ip),"%.15s",b[++kk]);
		    }
		else {
		    printf("Error: -h need ip adress\n");
		    return 0;
		    }
		printf("* Listen ip: %s\n",listen_ip);
		}
	    if(strcmp(b[kk],"-d")==0) {
		if(kk+1<a) {
		    debug=atol(b[++kk]);
		    if(debug<0)debug=0;
		    if(debug>2)debug=2;
		    }
		else {
		    printf("Error: -d need debug level\n");
		    return 0;
		    }
		printf("* Debug: %d\n",debug);
		}
	    if(strcmp(b[kk],"-a")==0) {
		printf("* Alternative authorization: enabled\n");
		aauth=1;
		}
	    if( (strcmp(b[kk],"--noold")==0) && (fblw==0) ) {
		printf("* no old files mode: enabled\n");
		noold=1;
		}
	    }
	if(a<2) {
	    printf("\nWelcome in RTG, runing mode:\n"
		   "ekgwapd <port> [-a --noold -h]           - standard, one user\n"
		   "ekgwapd <port> --freeblwr [-a -h]        - public gateway (30 slots)\n"
		   "ekgwapd <port> --freeblwr <i> [-a -h]    - public gateway (i slots)\n"
		   "ekgwapd <port> -u <name> [-a --noold -h] - one selected user\n"
		   "                                           (like '-u' in ekg)\n"
		   "Options:\n"
		   " --noold - dont write old and log files\n"
		   " -h <ip> - listen ip\n"
		   " -d <i>  - debug level i=0,1,2 (default 1)\n"
		   " -a      - alternative authorization\n\n");
	    return 0;
	    }
	}
    else {
    //odczyt home z passwd dla cgi
	int myuid=geteuid();
	FILE *passwd;
	char passl[501],*k,*puid,*ki;

	if((passwd=fopen("/etc/passwd","r"))) {
	    while(fgets(passl,500,passwd)) {
		k=(char *)index(passl,10);if(k!=NULL)k[0]=0;
		k=(char *)index(passl,':');if(k==NULL) return 0;
		k++[0]=0;
		puid=(char *)index(k,':');if(puid==NULL) return 0;
		puid++[0]=0;
		k=(char *)index(puid,':');if(k==NULL) return 0;
		k++[0]=0;
		if(atoi(puid)==myuid) {
	//	    printf("%d ",atoi(puid));
		    k=(char *)index(k,':');if(k==NULL) return 0;
		    k++[0]=0;
		    k=(char *)index(k,':');if(k==NULL) return 0;
		    k++[0]=0;
		    ki=(char *)index(k,':');if(ki==NULL) return 0;
		    ki++[0]=0;
		    snprintf(home,sizeof(home),"%s/%s",k,dirgg);
		    snprintf(logname,sizeof(logname),"%.50s",passl);
		}
	    }
	    fclose(passwd);
	    if(strlen(home)>1) {
		wap(wout,qstr,3000);
		printf("%.4000s",wout);
	    }
	return 0;
	}
    } // koniec cgi


    
    act.sa_handler = catcher;
    sigfillset(&(act.sa_mask));
    sigaction(SIGPIPE, &act, NULL);
    signal(SIGCHLD,SIG_IGN);
    
    server.sin_family = AF_INET;
    server.sin_port = swap_short(atoi(b[1]));
    if(strlen(listen_ip)==0)
	server.sin_addr.s_addr = INADDR_ANY;
    else
	server.sin_addr.s_addr = inet_addr(listen_ip);
    
    if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
        perror("[error] socked call failed");
        exit (1);
    }
    
    if ( bind(sockfd, (struct sockaddr *)&server, SIZE) == -1) {
        perror("[error] connect call failed");
        exit (1);
    }

    if( listen(sockfd, 5) == -1) {
        perror("[error] listen call failed");
        exit(1);
    }

    for(;;) { //glowna petla
	if( (newsockfd = accept(sockfd, NULL, NULL)) == -1) {
	    perror("[error] accept call failed");
	    continue;
	    }
	
	w=0;
	auth=0;

	//todo zrobic odpornym na dos, max ilosc forkow, max na minute itp.

	if( fork() == 0) {
	    int szlo_get=0;
	    int szlo_auth=0;
	    while(recv(newsockfd, &c, 1, 0) > 0) {
		if(w==1000) w=999; // uwaga na koniec linii !!!!!!!!!!!!!!!!!!
		if(c!=13 && c!=10)line[w++]=c;
		if(c==10) {
		    line[w]=0;
		    if(debug>1)printf("%s\n",line);

// pierwsza linia naglowka http
		    if( ((strstr(line,"GET")!=0)||strstr(line,"POST")!=0) && 
			!szlo_get) {
			szlo_get=1;
			if(fblw==1) {
			    char luid[21],*pk;
			    pk=(char *)index(line,'/');
			    if(pk!=NULL) {
				snprintf(luid,sizeof(luid),"%.20s",pk+1);
				pk=(char *)index(luid,'/');
				if(pk!=NULL) {
				    (pk+1)[0]=0;
				    if(atol(luid)!=0) {
					snprintf(home+strlen(home),sizeof(home)-strlen(home),
					    "/%ld",(long int)atol(luid));
					if(debug>0)printf("[%ld] freeblwr get, home: %s\n",(long int)atol(luid),home);
					fbuser=(long int)atol(luid);
					fblw=2; //user z numerkiem
					}
				    }
				}
			    }
			if(strstr(line,"?")!=0) { //query string :)
			    snprintf(qstr,sizeof(qstr),"%.501s",(char *)(index(line,'?')+1));
			    r=(char *)index(qstr,' ');
			    if(r==NULL) { //zle zapytanie
				shutdown(newsockfd,SHUT_RDWR);
				close(newsockfd);
				exit(0);
				}
			    r[0]=0;
			    }
			}
		    if(strstr(line,"Authorization")!=0 && 
			    (fblw==2 || fblw==0) && 
			    szlo_get && !szlo_auth) {
			szlo_auth=1;
//odczyt hasla z pliku
			snprintf(passfilename,sizeof(passfilename),"%s/wappasswd",home);
			if(debug>0)printf("[%ld] authfile: %s\n",fbuser,passfilename);
			if((passfile=fopen(passfilename,"r"))) {
			    fgets(passfilename,1000,passfile);
			    r=(char *)index(passfilename,10);
			    if(r!=NULL)r[0]=0;
			    r=(char *)index(passfilename,13);
			    if(r!=NULL)r[0]=0;
    			    fclose(passfile);
			    }
			else {
			    printf("[error] Brak pliku konfiguracyjnego z haslem do servera\n");
			    printf("[error] wykonaj htpasswd -c ~/.gg/wappasswd [login]\n");
			    auth=2;
			    }
			if(auth==0 && strlen(passfilename)==0) {
			    printf("[error] Uszkodzony plik z haslem wappasswd\n");
			    auth=2;
			    }
			if(auth==0) {
			    orglogin=passfilename;
			    orgpass=(char *)index(passfilename,':');
			    if(orgpass==NULL) {
				printf("[error] Uszkodzony plik z haslem wappasswd\n");
				auth=2;
				}
			    }
			if(auth==0) {
			    orgpass++[0]=0;
			    if(strlen(orglogin)==0 || strlen(orglogin)>30 || strlen(orgpass)==0 || strlen(orgpass)>30) {
				printf("[error] Uszkodzony plik z haslem wappasswd\n");
				auth=2;
				}
			    }
			if(auth==0) {
			    auth=mincrypt(line,orglogin,orgpass);
			    printf("[%ld] Login: %s - %s\n",fbuser,orglogin,(auth==1)?"OK":"false"); //haslo pobrane
			    }
			}
		    if(strlen(line)==0) { //server wbmp
			if(strcmp(qstr,"ekg.wbmp")==0 || 
				strcmp(qstr,"jest.wbmp")==0 || 
				strcmp(qstr,"sleep.wbmp")==0 || 
				strcmp(qstr,"busy.wbmp")==0 ||
				strcmp(qstr,"komorka.wbmp")==0) {
			    char *rys=NULL;
			    int size=0;
			    if(debug>0)printf("[%ld] wbmp: %s\n",fbuser,qstr);
			    if(strcmp(qstr,"ekg.wbmp")==0) {
				rys=ekgwbmp;
				size=sizeof(ekgwbmp);
			    }
			    else
			    if(strcmp(qstr,"jest.wbmp")==0) {
				rys=jestwbmp;
				size=sizeof(jestwbmp);
			    }
			    else
			    if(strcmp(qstr,"komorka.wbmp")==0) {
				rys=komorkawbmp;
				size=sizeof(komorkawbmp);
			    }
			    else
			    if(strcmp(qstr,"sleep.wbmp")==0) {
				rys=sleepwbmp;
				size=sizeof(sleepwbmp);
			    }
			    else
			    if(strcmp(qstr,"busy.wbmp")==0) {
				rys=busywbmp;
				size=sizeof(busywbmp);
			    }
			    snprintf(ol,sizeof(ol),"HTTP/1.0 200 OK\r\n"
"Content-type: image/vnd.wap.wbmp\r\n\r\n");
			    w=0;
			    do {
				k=send(newsockfd,&ol,strlen(ol),0);
				usleep(5);
				w++;
			    } while (strlen(ol)!=k || w>30);
			    if(w>30)exit(0); //connect timeout
			    w=0;
			    do {
				k=send(newsockfd,rys,size,0);
				usleep(5);
				w++;
			    } while (size!=k || w>30);
			    if(w>30)exit(0); //connect timeout
			    shutdown(newsockfd,SHUT_RDWR);
			    close(newsockfd);
			    exit(0);
			    }
			} //end server wbmp
		    if(strlen(line)==0) { //glowna tresc z wap()
			if(auth==1) { // autoryzacja udana mozna wejsc do rtg
			if(strncmp(qstr,"www",3)==0) {
			    //fewww(wout,qstr,12000);
			    //sprintf(ol,"HTTP/1.0 200 OK\r\n%.14000s",wout);
			    }
			else {
			    wap(wout,qstr,3000);
			    // printf("\nHTTP/1.0 200 OK\r\n%.4000s\n\n",wout);
			    snprintf(ol,sizeof(ol),"HTTP/1.0 200 OK\r\n%.4000s",wout);
			    }
			if(debug>0)printf("[%ld] sesja home: %s query: %s\n",fbuser,home,qstr);
			} //auth==1
			else { //auth!=1
			if(fblw==1 && strncmp(qstr,"fblw",4)==0) { // obsluga formularza zakladania nowej sesji
			    char *lg,*pas;
			    if(debug>0)printf("[freeblwr]: proba rejestracji nowej sesji %s\n",qstr);
			    snprintf(ol,sizeof(ol),"HTTP/1.0 200 OK\r\n"
"Expires: Mon, 26 Jul 1997 05:00:00 GMT\r\n"
"Cache-Control: no-cache, must-revalidate\r\n"
"Pragma: no-cache\r\n"
"Content-type: text/vnd.wap.wml\r\n"
"\r\n"
"<?xml version=\"1.0\"?>"
"<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\" \"http://www.wapforum.org/DTD/wml_1.1.xml\">"
""
"<wml>"
"<head>"
"<meta forua=\"true\" http-equiv=\"Cache-Control\" content=\"max-age=0\"/>"
"</head>");
			    lg=(char *)index(qstr+5,';');
			    if(lg==NULL) {
				if(debug>0)printf("[%ld] blad wywolania formularza\n",fbuser);
				sprintf(ol,"%s<card id=\"gg\" title=\"RTG FreeBlwr\"><p>error: blad wywolania formularza 1</p>",ol);
				}
			    else {
				lg++[0]=0;
                        	pas=(char *)index(lg,';');
                        	if(pas==NULL) {
				    if(debug>0)printf("[%ld] blad wywolania formularza\n",fbuser);
                            	    sprintf(ol,"%s<card id=\"gg\" title=\"RTG FreeBlwr\"><p>error: blad wywolania formularza 2</p>",ol);
                            	    }
				else {
				    int slot;
				    FILE *fslot;
				    char pome[200];
                        	    pas++[0]=0;
			    	    if(debug>0)printf("[freeblwr] Prba rejestracji konta: %s\n",lg);
				    slot=findslot(); // znajdz nowy wolny slot
				    if(slot!=0) { //zajmij slot tworzac query-log
					snprintf(pome,sizeof(pome),"%.150s/%d/wap-query.log",home,slot);
					// if
					fslot=fopen(pome,"w");
					fclose(fslot);
					// else ktos tez wpadl na ten slot, ale do przemyslenia
					// wiec slot=0
					}
				    if(slot==0) {
					if(debug>0)printf ("[error] nieudana, brak slotow\n");
					sprintf("%s<card id=\"gg\" title=\"RTG FreeBlwr\"><p>Blad utworzenia sesji, brak gniazd</p>",ol);
					}
				    else
				    if(strlen(pas)>30) {
					clrdir(slot,1);
					if(debug>0)printf ("[error] nieudana, zbyt dlugie haslo\n");
					sprintf("%s<card id=\"gg\" title=\"RTG FreeBlwr\"><p>Blad utworzenia sesji, zbyt dlugie haslo</p>",ol);
					}
				    else {
					FILE *exez;
					int pomi;
// czy znaczki w hasle sa dozwolone
					for(pomi=0;pomi<strlen(pas);pomi++)
					    if(!((pas[pomi]>='A' && pas[pomi]<='Z') ||
					       (pas[pomi]>='a' && pas[pomi]<='z') ||
					       (pas[pomi]>='0' && pas[pomi]<='9')	
					      )) pas[pomi]='_';
					if(debug>0)printf ("[freeblwr] udana slot: %d\n",slot);
// zakladanie pliku z haslem (narazie brzydko, ale przerobie na c)
					snprintf(pome,sizeof(pome),"htpasswd -bc %s/%d/wappasswd %ld %s",home,slot,(long int)atol(lg),pas);
					exez=popen(pome,"r");
					sleep(1);
					pclose(exez);
					if(1) { //jesli zakladanie pliku z haslem sie powiodlo
					    FILE *pwap;
// uruchamianie ekg dla slotu
					    snprintf(pome,sizeof(pome),"screen -dmS fekg ./bin/ekg -u %d -c %s/%d/pipewap",slot,home,slot);
					    exez=popen(pome,"r");
					    sleep(2);
					    pclose(exez);
					    snprintf(pome,sizeof(pome),"%s/%d/pipewap",home,slot);
					    if((pwap=fopen(pome,"r+"))) { // zaprogramujmy ekg
						fprintf(pwap,"/set uin %ld\n",(long int)atol(lg));
						fprintf(pwap,"/set password %s\n",pas);
						fprintf(pwap,"/set auto_save 1\n");
// user si sam poczy jak si zaloguje
						// fprintf(pwap,"/connect\n");
						fflush(pwap);
						sleep(1);
//						fprintf(pwap,"/list -g\n");
						sleep(1);
						fclose(pwap);
						sprintf(ol,"%s<card id=\"gg\" title=\"RTG FreeBlwr\" ontimer=\"/%d/\">"
							   "<timer name=\"time3\" value=\"1\"/>",ol,slot);
						if(debug>0)printf("[freeblwr] udana, le przekierowanie slot: %d\n",slot);
						}
					    else {
						//ekg chyba nie ruszyl
						clrdir(slot,1);
						if(debug>0)printf("[error] Problem z uruchomieniem ekg slot: %d\n",slot);
						sprintf(ol,"%s<card id=\"gg\" title=\"RTG FreeBlwr\"><p>Nieudane uruchomienie ekg</p>",ol);
						}
					    }
					else { // nieudane zakladanie pliku z haslem
					    snprintf(pome,sizeof(pome),"%.150s/%d/wap-query.log",home,slot);
					    unlink(pome);
					    snprintf(pome,sizeof(pome),"%.150s/%d/",home,slot);
					    rmdir(pome);
					    if(debug>0)printf ("[freeblwr] nieudana, niezlorzono pliku z haslem, slot: %d\n",slot);
					    sprintf("%s<card id=\"gg\" title=\"RTG FreeBlwr\"><p>Nieudane zakladanie pliku z haslem</p>",ol);
					    }
					}
				    }
				}
			    sprintf(ol,"%s</card></wml>",ol);
			    } //koniec obsugi formularza nowej sesji
			else {
			    if(fblw==1) { //user bez mumerka czyli zakladanie
				if(debug>0)printf("[freeblwr] Formularz nowej sesji\n");
				snprintf(ol,sizeof(ol),"HTTP/1.0 200 OK\r\n"
"Expires: Mon, 26 Jul 1997 05:00:00 GMT\r\n"
"Cache-Control: no-cache, must-revalidate\r\n"
"Pragma: no-cache\r\n"
"Content-type: text/vnd.wap.wml\r\n"
"\r\n"
"<?xml version=\"1.0\"?>\r\n"
"<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\" \"http://www.wapforum.org/DTD/wml_1.1.xml\">\r\n"
"\r\n"
"<wml>\r\n"
"<head><meta forua=\"true\" http-equiv=\"Cache-Control\" content=\"max-age=0\"/>\r\n"
"</head>\r\n"
"<card id=\"gg\" title=\"RTG FreeBlwr\" newcontext=\"true\">\r\n"
"<p>Gg number:</p><p><input format=\"*N\" name=\"g\" type=\"text\"/></p>\r\n"
"<p>Gg passwd:</p><p><input format=\"*M\" name=\"p\" type=\"text\"/></p>\r\n"
"<p><anchor>Send<go href=\"?fblw;s;$(g:escape);$(p:escape)\" method=\"get\"/></anchor></p>\r\n"
"</card></wml>\r\n");
				}
			    else { //gdy nie freeblwr to leci brak autoryzacji
				if(debug>0)printf("[rtg] Formularz HTTP/401\n");
				snprintf(ol,sizeof(ol),"HTTP/1.0 401 Authorization Required\r\n"
"Date: Wed, 31 Jul 2002 15:28:06 GMT\r\n"
"Server: GG/0.0.1 (Unix) Debian GNU/Linux\r\n"
"WWW-Authenticate: Basic realm=\"gg zone\"\r\n"
"Keep-Alive: timeout=15, max=100\r\n"
"Connection: Keep-Alive\r\n"
"Transfer-Encoding: chunked\r\n"
"Content-Type: text/html; charset=iso-8859-1\r\n"
"\r\n"
"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">\r\n"
"<HTML><HEAD>\r\n"
"<TITLE>401 Authorization Required</TITLE>\r\n"
"</HEAD><BODY>\r\n"
"<H1>Authorization Required</H1>\r\n"
"This server could not verify that you\r\n"
"are authorized to access the document\r\n"
"requested.  Either you supplied the wrong\r\n"
"credentials (e.g., bad password), or your\r\n"
"browser doesn't understand how to supply\r\n"
"the credentials required.<P>\r\n"
"</BODY></HTML>\r\n"
"\r\n");
				}
			    }
			} //auth==0
		    } //line==0
		    if(strlen(line)==0)
			{
			w=0;
			do {
			    k=send(newsockfd,&ol,strlen(ol),0);
			    usleep(5);
			    w++;
			    }
			while (strlen(ol)!=k || w>30);
			shutdown(newsockfd,SHUT_RDWR);
			close(newsockfd);
			if(debug>1)printf("[query]\n%s\n\n",ol);
//			printf("Baby killed\n");
			exit(0);
			}
		    w=0;
		    }
		}    
	    close(newsockfd);
	    exit(0);
	    }
	    else { 
		//glowny proces
		close(newsockfd);
	
	//// czasami moze byc potrzebny, gdy zostaja zombie
	// wait(0);
		}
	}
}


void catcher(int sig)
{
    close(newsockfd);
    printf("Albercik, wychodzimy!\n");
    exit(0);
}
